#include "stdinc.h"
#define KEY VK_SCROLL 

WTWFUNCTIONS* wtw = 0;
HANDLE ProtoHook, WndChatHook3;
//WNDPROC g_OldWndProc;

WTWPLUGINFO plugInfo = {
   sizeof(WTWPLUGINFO),
   L"wtwScroll",
   L"Migacz",
   L"n3o (c) 2009",
   L"n3o",
   L"lukasz.krutul@gmail.com",
   L"http://www.lukasz.krutul.pl",
   L"",
   PLUGIN_API_VERSION,
   MAKE_QWORD_VERSION(0, 2, 0, 30),
   WTW_CLASS_UTILITY,
   0,
   L"{35EAB0E4-3F84-4081-A7A1-4976BE125DA9}",
   0, 0, 0, 0 //zarezerwowane
};


extern "C" {

/**
 * Czy miganie jest zatrzymane
 */
bool bPaused = true;

/**
 * Pozycja klawisza przed rozpoczeniem mrugania
 * true - zapalona kontrolka, false - zgaszona
 */
bool bDefault = false;

/**
 * Czy sprawdzamy pierwsza pozycje 
 */
bool bFirst = true;

/**
 * Wraca do domyslnej pozycji klawisza
 */
void returnDefault() {
	bPaused = true;
	BYTE keyState[256];
    GetKeyboardState((LPBYTE)&keyState);

	if(bDefault) {
		__LOG(wtw, L"SCR", L"Set default position: PRESSED", WTW_LOG_LEVEL_DEBUG_X);
	} else {
		__LOG(wtw, L"SCR", L"Set default position: RELEASED", WTW_LOG_LEVEL_DEBUG_X);
	}
	
	if((keyState[KEY] & 1)) {
		__LOG(wtw, L"SCR", L"Current: PRESSED", WTW_LOG_LEVEL_DEBUG_X);
	} else {
		__LOG(wtw, L"SCR", L"Current: RELEASED", WTW_LOG_LEVEL_DEBUG_X);
	}

	if( (bDefault && !(keyState[KEY] & 1)) ||
        (!bDefault && (keyState[KEY] & 1)) )
    {
		__LOG(wtw, L"SCR", L"Simulate a key press", WTW_LOG_LEVEL_DEBUG_X);
        // Simulate a key press
        keybd_event( KEY,
                     0x45,
                     KEYEVENTF_EXTENDEDKEY | 0,
                     0 );

        // Simulate a key release
        keybd_event( KEY,
                     0x45,
                     KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP,
                     0);
    }
}

/**
 * onActivate
 */
WTW_PTR ChatActProcess(WTW_PARAM wP, WTW_PARAM wL, void* ) {
	// wP - wtwContactDef*, lP - * wtwChatWindowInfo
	
	if(!bPaused) {
		bPaused = true; // zatrzymujemy timer
		returnDefault(); // wracamy do domyslnej pozycji klawisza
		__LOG(wtw, L"SCR", L"Chat window activated - scroll blip stopped", WTW_LOG_LEVEL_DEBUG_X);
	}
	return 0;
}


WTWPLUGINFO* __stdcall queryPlugInfo(DWORD /*apiVersion*/, DWORD /*masterVersion*/) {
    return &plugInfo;
}

/**
 * Zadanie timera
 */
WTW_PTR BlinkScroll(WTW_PARAM wP, WTW_PARAM wL, void*)
{
	if(!bPaused && wtw->fnCall(WTW_FUNCT_IS_CHATWND_ACTIVE, 0, 0)) {
		__LOG(wtw, L"SCR", L"Timer: Chat window is active - stopping", WTW_LOG_LEVEL_DEBUG_X);
		bPaused = true;
		returnDefault();
		return 0;
	}

	if(!bPaused && bFirst) {
		BYTE keyState[256];
   		GetKeyboardState((LPBYTE)&keyState);

		bDefault = (keyState[KEY] & 1) ? true : false;
		if(bDefault) {
			__LOG(wtw, L"SCR", L"Default position: PRESSED", WTW_LOG_LEVEL_DEBUG_X);
		} else {
			__LOG(wtw, L"SCR", L"Default position: RELEASED", WTW_LOG_LEVEL_DEBUG_X);
		}
		bFirst = false;
	}

	if(!bPaused) {
		// Simulate a key press
        keybd_event( KEY,
                     0x45,
                     KEYEVENTF_EXTENDEDKEY | 0,
                     0 );

        // Simulate a key release
        keybd_event( KEY,
                     0x45,
                     KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP,
                     0);
	}
	return 0;
}

/**
 * Przetwarzanie zdarzen protokolu 
 * wParam wtwProtocolEvent*
 * lparam wtwMessageGef*
 */
WTW_PTR ProtoProcess(WTW_PARAM wP, WTW_PARAM wL, void*) {
	wtwProtocolEvent *proto = (wtwProtocolEvent *) wP;
	
	if(bPaused && proto->event == WTW_PEV_MESSAGE_RECV) {
		wtwMessageDef *msg_org = (wtwMessageDef *) wL;
		// kInfo zbiera informacje o stanach
		if((msg_org->msgFlags & WTW_MESSAGE_FLAG_INFO) 
			|| (msg_org->msgFlags & WTW_MESSAGE_FLAG_ERROR)
			|| (msg_org->msgFlags & WTW_MESSAGE_FLAG_WARNING)) {
			return 0;
		}

		// Okno nieaktywne
		if (!wtw->fnCall(WTW_FUNCT_IS_CHATWND_ACTIVE, 0, 0)) {
			// nadchodzaca wiadomosc
			bFirst 	= true;
			bPaused = false; // uruchamiamy timer
			__LOG(wtw, L"SCR", L"Chat window not active - scroll blip started", WTW_LOG_LEVEL_DEBUG_X);
		}

	} else if(!bPaused && proto->event == WTW_PEV_MESSAGE_SEND) {
		// inna 
		bPaused = true; // zatrzymujemy timer
		returnDefault(); // wracamy do domyslnej pozycji klawisza
		__LOG(wtw, L"SCR", L"Outgoing message send - scroll blip stopped", WTW_LOG_LEVEL_DEBUG_X);
	}
	return 0;
}

/**
 * Zaladowanie wtyczki
 */
int __stdcall pluginLoad(DWORD /*callReason*/, WTWFUNCTIONS* f) {
	wtw = f;
	wtwTimerDef timer;
	initStruct(timer);
	timer.iD = L"wScroll";
	timer.sleepTime = 200;
	timer.callBack = BlinkScroll;
	//timer.flags = WTW_TIMER_FLAG_ONE_TICK;

	wtw->fnCall(WTW_TIMER_CREATE,(WTW_PARAM) &timer, 0);
	ProtoHook = wtw->evHook(WTW_ON_PROTOCOL_EVENT, ProtoProcess, wtw);
	WndChatHook3 = wtw->evHook(WTW_EVENT_ON_CHATWND_ACTIVATE, ChatActProcess, 0);
    return 0;
}

/**
 * Wyladowanie wtyczki
 */
int __stdcall pluginUnload(DWORD /*callReason*/) {
	wtw->fnCall(WTW_TIMER_DESTROY, (WTW_PARAM) L"wScroll", 0);
	if(!bPaused) {
		bPaused = true;
		returnDefault();
	}
	wtw->evUnhook(ProtoHook);
	wtw->evUnhook(WndChatHook3);
    return 0;
}
} // extern "C"
